long WINAPI CopyDialogProc(HANDLE hDlg, int Msg,int Param1,long Param2)
{
  FarDialogItem DialogItem;
  FarDialogItemData Caption1,Caption2;
  switch(Msg)
  {
    case DN_INITDIALOG:
      Info.SendDlgMessage(hDlg,DM_SETTEXTLENGTH,2,MAX_PATH-1);
    case DN_BTNCLICK:
      Info.SendDlgMessage(hDlg,DM_GETDLGITEM,6,(long)&DialogItem);
      Info.SendDlgMessage(hDlg,DM_ENABLE,10,!DialogItem.Selected);
      Info.SendDlgMessage(hDlg,DM_GETDLGITEM,8,(long)&DialogItem);
      Info.SendDlgMessage(hDlg,DM_ENABLE,9,DialogItem.Selected);
      if(DialogItem.Selected)
      {
        Caption1.PtrData=GetMsg(mCpyDlgMoveTitle);
        Caption1.PtrLength=strlen(Caption1.PtrData);
        Caption2.PtrData=MsgMove;
        Caption2.PtrLength=strlen(Caption2.PtrData);
      }
      else
      {
        Caption1.PtrData=GetMsg(mCpyDlgCopyTitle);
        Caption1.PtrLength=strlen(Caption1.PtrData);
        Caption2.PtrData=MsgCopy;
        Caption2.PtrLength=strlen(Caption2.PtrData);
      }
      Info.SendDlgMessage(hDlg,DM_SETTEXT,0,(long)&Caption1);
      Info.SendDlgMessage(hDlg,DM_SETTEXT,1,(long)&Caption2);
      break;
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI DelDialogProc(HANDLE hDlg, int Msg,int Param1,long Param2)
{
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI InfoDialogProc(HANDLE hDlg, int Msg,int Param1,long Param2)
{
  switch(Msg)
  {
    case DN_INITDIALOG:
      Info.SendDlgMessage(hDlg,DM_SETDLGDATA,0,Param2);
      break;
    case DN_BTNCLICK:
      if(Param1==3)
      {
        DWORD send[3]={OPERATION_INFO,INFOFLAG_PAUSE};
        DWORD dwBytesWritten;
        send[2]=Info.SendDlgMessage(hDlg,DM_GETDLGDATA,0,0);
        HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
        if(hPipe!=INVALID_HANDLE_VALUE)
        {
          WriteFile(hPipe,send,sizeof(send),&dwBytesWritten,NULL);
          CloseHandle(hPipe);
        }
      }
      break;
    case DN_ENTERIDLE:
      DWORD send[3]={OPERATION_INFO,INFOFLAG_BYHANDLE};
      send[2]=Info.SendDlgMessage(hDlg,DM_GETDLGDATA,0,0);
      InfoRec receive;

      DWORD dwBytesRead,dwBytesWritten;

      receive.info.type=INFOTYPE_INVALID;

      HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
      if(hPipe!=INVALID_HANDLE_VALUE)
      {
        WriteFile(hPipe,send,sizeof(send),&dwBytesWritten,NULL);
        ReadFile(hPipe,&receive,sizeof(receive),&dwBytesRead,NULL);
        CloseHandle(hPipe);
      }
      else if(GetLastError()==ERROR_PIPE_BUSY) break;
      if(receive.info.type>INFOTYPE_INVALID)
      {
        char SrcA[MAX_PATH];
        FarDialogItemData Caption;
        if(receive.pause)
          Caption.PtrData=GetMsg(mInfoDlgContinue);
        else
          Caption.PtrData=GetMsg(mInfoDlgPause);
        Caption.PtrLength=strlen(Caption.PtrData);
        Info.SendDlgMessage(hDlg,DM_SETTEXT,3,(long)&Caption);
        WideCharToMultiByte(CP_OEMCP,0,receive.Src,-1,SrcA,MAX_PATH,NULL,NULL);
        Caption.PtrData=FSF.TruncPathStr(SrcA,66);
        Caption.PtrLength=strlen(Caption.PtrData);
        Info.SendDlgMessage(hDlg,DM_SETTEXT,5,(long)&Caption);
        if(receive.info.type!=INFOTYPE_DELETE)
        {
          WideCharToMultiByte(CP_OEMCP,0,receive.Dest,-1,SrcA,MAX_PATH,NULL,NULL);
          Caption.PtrData=FSF.TruncPathStr(SrcA,66);
          Caption.PtrLength=strlen(Caption.PtrData);
          Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&Caption);
          if((receive.info.InfoEx)&&(receive.TotalSize))
          {
            FILETIME start,current,finish; SYSTEMTIME CurrTime,FinishTime;
            unsigned long long llstart,llcurrent,llfinish; unsigned int percent;
            GetLocalTime(&CurrTime);
            SystemTimeToFileTime(&receive.StartTime,&start);
            SystemTimeToFileTime(&CurrTime,&current);
            memcpy(&llstart,&start,sizeof(llstart));
            memcpy(&llcurrent,&current,sizeof(llcurrent));
            llfinish=llstart;
            if(receive.CurrentSize!=0LL)
              llfinish+=(llcurrent-llstart)*receive.TotalSize/(receive.CurrentSize+receive.CurrentSizeAdd);
            memcpy(&finish,&llfinish,sizeof(llfinish));
            FileTimeToSystemTime(&finish,&FinishTime);

            FSF.sprintf(SrcA,GetMsg(mInfoDlgStatus1),receive.CurrentSize+receive.CurrentSizeAdd,receive.TotalSize);
            Caption.PtrData=SrcA;
            Caption.PtrLength=strlen(Caption.PtrData);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,10,(long)&Caption);
            sprintf(SrcA,GetMsg(mInfoDlgStatus2),receive.StartTime.wDay,receive.StartTime.wMonth,receive.StartTime.wYear,receive.StartTime.wHour,receive.StartTime.wMinute,receive.StartTime.wSecond,FinishTime.wDay,FinishTime.wMonth,FinishTime.wYear,FinishTime.wHour,FinishTime.wMinute,FinishTime.wSecond);
            Caption.PtrData=SrcA;
            Caption.PtrLength=strlen(Caption.PtrData);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,11,(long)&Caption);
            unsigned long long CPS=((llcurrent-llstart)/10000000);
            if(CPS!=0LL)
              CPS=(receive.CurrentSize+receive.CurrentSizeAdd)/CPS;
            FSF.sprintf(SrcA,GetMsg(mInfoDlgStatus3),receive.Errors,CPS);
            Caption.PtrData=SrcA;
            Caption.PtrLength=strlen(Caption.PtrData);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,12,(long)&Caption);

            char *Fill=GetMsg(mInfoDlgFill);
            char Gauge[62];
            percent=0;
            if(receive.TotalSize!=0LL)
              percent=(receive.CurrentSize+receive.CurrentSizeAdd)*61/receive.TotalSize;
            for(unsigned int i=0;i<percent;i++)
              Gauge[i]=Fill[0];
            for(unsigned int i=percent;i<61;i++)
              Gauge[i]=Fill[1];
            Gauge[61]=0;
            percent=0;
            if(receive.TotalSize!=0LL)
              percent=(receive.CurrentSize+receive.CurrentSizeAdd)*100/receive.TotalSize;
            sprintf(SrcA,GetMsg(mInfoDlgStatus4),percent,Gauge);
            Caption.PtrData=SrcA;
            Caption.PtrLength=strlen(Caption.PtrData);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,13,(long)&Caption);
          }
        }
        //refresh
        Info.SendDlgMessage(hDlg,DM_SETREDRAW,0,0);
      }
      else
        Info.SendDlgMessage(hDlg,DM_CLOSE,-1,0);
      break;
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI ConfigDialogProc(HANDLE hDlg, int Msg,int Param1,long Param2)
{
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}
