int Config()
{
  //Show dialog
  /*
    0000000000111111111122222222223333333333444444444455555555556666666666777777
    0123456789012345678901234567890123456789012345678901234567890123456789012345
  00                                                                            00
  01    Backgroung copy ͻ   01
  02     Copy Ŀ    02
  03     ( ) Overwrite all existing files                                   03
  04     ( ) Append to all existing files                                   04
  05     ( ) Skip all existing files                                        05
  06     ( ) Refresh old files                                              06
  07                                                                        07
  08     [ ] Use system copy history                                        08
  09     [ ] Clear R/O attribute on &source                                 09
  10     [ ] Clear R/O attribute on &destination                            10
  11     [ ] Abort on error                                                 11
  12     [ ] Show full info                                                 12
  13        13
  14     Delete Ŀ    14
  15     [ ] Clear R/O attribute                                            15
  16     [ ] Abort on error                                                 16
  17        17
  18   Ķ   18
  19                    [ Save ]              [ Cancel ]                      19
  20   ͼ   20
  21                                                                            21
    0000000000111111111122222222223333333333444444444455555555556666666666777777
    0123456789012345678901234567890123456789012345678901234567890123456789012345
  */
 
  static struct InitDialogItem InitItems[]={
  /* 0*/  {DI_DOUBLEBOX,3,1,72,20,0,0,0,0,(char *)mName},
  /* 1*/  {DI_SINGLEBOX,5,2,70,13,0,0,DIF_LEFTTEXT,0,(char *)mCpyDlgCopyTitle},
  /* 2*/  {DI_RADIOBUTTON,7,3,0,0,0,0,DIF_GROUP,0,(char *)mCpyDlgOpt1},
  /* 3*/  {DI_RADIOBUTTON,7,4,0,0,0,0,0,0,(char *)mCpyDlgOpt2},
  /* 4*/  {DI_RADIOBUTTON,7,5,0,0,0,0,0,0,(char *)mCpyDlgOpt3},
  /* 5*/  {DI_RADIOBUTTON,7,6,0,0,0,0,0,0,(char *)mCpyDlgOpt4},
  /* 6*/  {DI_CHECKBOX,7, 8,0,0,0,0,0,0,(char *)mConfigHistory},
  /* 7*/  {DI_CHECKBOX,7, 9,0,0,0,0,0,0,(char *)mCpyDlgChk2},
  /* 8*/  {DI_CHECKBOX,7,10,0,0,0,0,0,0,(char *)mCpyDlgChk3},
  /* 9*/  {DI_CHECKBOX,7,11,0,0,0,0,0,0,(char *)mCpyDlgChk4},
  /*10*/  {DI_CHECKBOX,7,12,0,0,0,0,0,0,(char *)mConfigFullInfo},

  /*11*/  {DI_SINGLEBOX,5,14,70,17,0,0,DIF_LEFTTEXT,0,(char *)mDelDlgTitle},
  /*12*/  {DI_CHECKBOX,7,15,0,0,0,0,0,0,(char *)mDelDlgChk1},
  /*13*/  {DI_CHECKBOX,7,16,0,0,0,0,0,0,(char *)mConfigDelAbort},

  /*14*/  {DI_TEXT,-1,18,0,0,0,0,DIF_SEPARATOR,0,""},
  /*15*/  {DI_BUTTON,0,19,0,0,0,0,DIF_CENTERGROUP,1,(char *)mConfigSave},
  /*16*/  {DI_BUTTON,0,19,0,0,0,0,DIF_CENTERGROUP,0,(char *)mConfigCancel}
  };

  struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
  InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));
  DialogItems[2+Opt.CopyType].Selected=1;
  DialogItems[6].Selected=Opt.CopyHistory;
  DialogItems[7].Selected=Opt.CopyROSrc;
  DialogItems[8].Selected=Opt.CopyRODest;
  DialogItems[9].Selected=Opt.CopyAbort;
  DialogItems[10].Selected=Opt.CopyFullInfo;

  DialogItems[12].Selected=Opt.DeleteRO;
  DialogItems[13].Selected=Opt.DeleteAbort;
  
  int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,22,"Config",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,ConfigDialogProc,0);
  if (DlgCode!=15)
    return(FALSE);

  Opt.CopyType=0;
  int i=2;
  while(!DialogItems[i].Selected) {i++; Opt.CopyType++;}
  Opt.CopyHistory=DialogItems[6].Selected;
  Opt.CopyROSrc=DialogItems[7].Selected;
  Opt.CopyRODest=DialogItems[8].Selected;
  Opt.CopyAbort=DialogItems[9].Selected;
  Opt.CopyFullInfo=DialogItems[10].Selected;

  Opt.DeleteRO=DialogItems[12].Selected;
  Opt.DeleteAbort=DialogItems[13].Selected;

  HKEY hKey;
  DWORD Disposition;
  if((RegCreateKeyEx(HKEY_CURRENT_USER,PluginRootKey,0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition)) == ERROR_SUCCESS)
  {
    RegSetValueEx(hKey,"Options",0,REG_BINARY,(LPBYTE)&Opt,sizeof(Opt));
    RegCloseKey(hKey);
  }
  return(TRUE);
}
